c     program Cabundan
c      
      implicit real*8(a-h,l-z)
      dimension lR2(999),lR3(999),lN2(999),lS2(999)
      dimension OH(999),NH(999),t(999)
      dimension P(999),lN2R2(999),lS2R2(999)
      common x(11,999),y(999),a(11,11),b(11),c(11),kx,keq

c
c
      open (1,file='Reference10.dat')
      open (2,file='LineInten.dat')

      open (12,file='Abundances.dat')

      keqo=12 
      eOHsel=0.10
      dOHlimo=2.0*eOHsel

      
      j=1
   31 continue   
      read (1,*,END=32) lR3(j),lR2(j),lN2(j),lS2(j),OH(j),NH(j),t(j)
      w3=10.**(lR3(j))
      w2=10.**(lR2(j))
      P(j)=w3/(w3+w2)
      lN2R2(j)=lN2(j)-lR2(j)
      lS2R2(j)=lS2(j)-lR2(j)
      j=j+1
      go to 31
 32   continue
      jpoint=j-1


      write (12,112) 
 112  format(/'  n','     O/H  ','    N/H ','      t'/)
      write (*,112) 


 100  continue
      read (2,*,END=101) jspectr,R2x,R3bx,N2bx,S2ax,S2bx
      if(R3bx.le.0.0) go to 101
      
      R3x=1.33*R3bx
      N2x=1.33*N2bx
      S2x=S2ax+S2bx
      Px=R3x/(R3x+R2x)
      lN2R2x=dlog10(N2x/R2x)
      lN2S2x=dlog10(N2x/S2x)
      lS2R2x=dlog10(S2x/R2x)
      lR3x=dlog10(R3x)



c
c      S e a r c h    f o r    c o u n t e r p a r t
c
      kx=5

      dFmin=9.9 
      do 151 j=1,jpoint
      dF1=dabs(lR3(j)-lR3x)
      dF2=dabs(P(j)-Px)
      dF3=dabs(lN2R2(j)-lN2R2x)
      dF4=dabs(lS2R2(j)-lS2R2x)
      dF=dsqrt(dF1*dF1+dF2*dF2+dF3*dF3+dF4*dF4)
      if(dF.lt.dFmin) then
      jmin=j
      dFmin=dF 
      end if
 151  continue

      OHm=OH(jmin)
      NHm=NH(jmin)
      tm=t(jmin)


c     O x y g e n    a b u n d a n c e 

      dOHlim=dOHlimo
 152  continue
      j=1
      keq=0
      do 141 k=1,jpoint
      dOH=dabs(OH(k)-OHm)
      if(dOH.le.dOHlim) then 
      x(1,j)=1.0
      x(2,j)=P(k)
      x(3,j)=lR3(k)
      x(4,j)=lN2R2(k)
      x(5,j)=lS2R2(k)
      y(j)=OH(k)
      j=j+1
      keq=keq+1
      end if
 141  continue

      if(keq.lt.keqo) then
      dOHlim=dOHlim+0.05
      go to 152
      end if
      
      call coeffons

      c1=c(1)
      c2=c(2)
      c3=c(3)
      c4=c(4)
      c5=c(5)


      OHc=c1+c2*Px+c3*lR3x+c4*lN2R2x+c5*lS2R2x

c     N i t r o g e n     a b u n d a n c e 


      j=1
      keq=0
      do 142 k=1,jpoint
      dOH=dabs(OH(k)-OHm)
      if(dOH.le.dOHlim) then 
      x(1,j)=1.0
      x(2,j)=P(k)
      x(3,j)=lR3(k)
      x(4,j)=lN2R2(k)
      x(5,j)=lS2R2(k)
      y(j)=NH(k)
      j=j+1
      keq=keq+1
      end if
 142  continue

      
      call coeffons

      c1=c(1)
      c2=c(2)
      c3=c(3)
      c4=c(4)
      c5=c(5)

      NHc=c1+c2*Px+c3*lR3x+c4*lN2R2x+c5*lS2R2x

c     E l e c t r o n    t e m p e r a t u r e 

      j=1
      keq=0
      do 143 k=1,jpoint
      dOH=dabs(OH(k)-OHm)
      if(dOH.le.dOHlim) then 
      x(1,j)=1.0
      x(2,j)=P(k)
      x(3,j)=lR3(k)
      x(4,j)=lN2R2(k)
      x(5,j)=lS2R2(k)
      y(j)=t(k)
      j=j+1
      keq=keq+1
      end if
 143  continue

      
      call coeffons

      c1=c(1)
      c2=c(2)
      c3=c(3)
      c4=c(4)
      c5=c(5)

      tc=c1+c2*Px+c3*lR3x+c4*lN2R2x+c5*lS2R2x


      write (12,12) jspectr,OHc,NHc,tc
 12   format(i3,3f9.2)
      write (*,12) jspectr,OHc,NHc,tc


      go to 100

 101  continue

      stop
      end


      subroutine coeffons
      implicit real*8(a-h,o-z)
      common x(11,999),y(999),a(11,11),b(11),c(11),kx,keq


      do 44 i=1,kx
      b(i)=0.0
      do 44 j=1,kx
      a(i,j)=0.0
 44   continue

      do 45 i=1,kx
      do 45 k=1,kx
      do 45 j=1,keq
      a(i,k)=a(i,k)+x(i,j)*x(k,j)
 45   continue

      do 46 i=1,kx
      do 46 j=1,keq
      b(i)=b(i)+x(i,j)*y(j)
 46   continue

      n=kx
      nm1=kx-1
      do 300 k=1,nm1
      kp1=k+1
      l=k
      do 400 i=kp1,n
      if(dabs(a(i,k))-dabs(a(l,k))) 400,400,401
  401 l=i
  400 continue
      if(l-k) 500,500,405
  405 do 410 j=k,n
      temp=a(k,j)
      a(k,j)=a(l,j)
  410 a(l,j)=temp
      temp=b(k)
      b(k)=b(l)
      b(l)=temp
  500 do 300 i=kp1,n
      factor=a(i,k)/a(k,k)
      a(i,k)=0
      do 301 j=kp1,n
  301 a(i,j)=a(i,j)-factor*a(k,j)
  300 b(i)=b(i)-factor*b(k)
      c(n)=b(n)/a(n,n)
      i=nm1
  710 ip1=i+1
      sum=0.
      do 700 j=ip1,n
  700 sum=sum+a(i,j)*c(j)
      c(i)=(b(i)-sum)/a(i,i)
      i=i-1
      if(i) 800,800,710
  800 continue
      return
      end


